//+------------------------------------------------------------------+
//|                                                CArrayRing256.mqh |
//|                               Copyright 2012, Konstantin Gruzdev |
//|                            https://login.mql5.com/ru/users/Lizar |
//|                                             Revision 29 Nov 2012 |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2012, Konstantin Gruzdev"
#property link        "https://login.mql5.com/ru/users/Lizar"

//+------------------------------------------------------------------+
//| Class CArrayRing256                                              |
//| Appointment:           |
//|  ,             |
//|   .              |
//|       :                |
//|   -  (256 )    |
//|   -                                 |
//+------------------------------------------------------------------+
class CArrayRing256
  {
private:
   double            m_data[];         //   
   int               m_size;           //  
   uchar             m_last_pos;       //    

public:
                     CArrayRing256();
                    ~CArrayRing256()               { ArrayFree(m_data);                         }
   //---   :
   bool              Init(double volue=EMPTY_VALUE);             
   //---    :
   int               Size()                        { return m_size-1;                           }
   //---      :
   void              Add(const double element)     { m_data[++m_last_pos]=element;              } 
   //---       :
   double            At(const uchar index) const   { return(m_data[uchar(m_last_pos-index)]);   }
   double operator   [](const uchar index) const   { return(At(index));                         }
   //---        :
   double            Last() const                  { return(m_data[m_last_pos]);                } 
   //---       :
   void              Last(const double element)    { m_data[m_last_pos]=element;                }  
   //---       :
   void              Update(const double element,const uchar index=0);  
  };
//+------------------------------------------------------------------+
//| .                                                     |
//+------------------------------------------------------------------+
CArrayRing256::CArrayRing256()
  {
   m_last_pos=0;                                                        //   
   m_size=ArraySize(m_data);                                            //    
  }
//+------------------------------------------------------------------+
//|   .                                      |
//+------------------------------------------------------------------+
bool CArrayRing256::Init(double volue=EMPTY_VALUE)
  {
   m_last_pos=0;                                                        //   
   bool result=(m_size=ArrayResize(m_data,UCHAR_MAX+1))==UCHAR_MAX+1;   //     
   ArrayFill(m_data,0,m_size,volue);                                    //    
   return(result);                  
  }  
//+------------------------------------------------------------------+
//|      .           |
//+------------------------------------------------------------------+
void CArrayRing256::Update(const double element,const uchar index=0)
  {
   m_data[uchar(m_last_pos-index)]=element;
  }